/*
 * Enhanced Music Controller
 * Copyright (C) 2018-2023 by Mikhail Kulesh
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details. You should have received a copy of the GNU General
 * Public License along with this program.
 */

package com.mkulesh.onpc.iscp.messages;

import com.mkulesh.onpc.iscp.EISCPMessage;
import com.mkulesh.onpc.iscp.ISCPMessage;

import androidx.annotation.NonNull;

/*
 * NET/USB List Info (Update item, need processing XML data, for Network Control Only)
 */
public class ListItemInfoMsg extends ISCPMessage
{
    public final static String CODE = "NLU";

    private final int index, number;

    ListItemInfoMsg(EISCPMessage raw) throws Exception
    {
        super(raw);
        index = Integer.parseInt(data.substring(0, 4), 16);
        number = Integer.parseInt(data.substring(4, 8), 16);
    }

    @NonNull
    @Override
    public String toString()
    {
        return CODE + "[" + data + "; " + index + "/" + number + "]";
    }
}
